#include <string>
#include <vector>
#include <iostream>

#include <arc/rlsreplicamanager.h>

using namespace std;
using namespace arc;

int main()
{
	RLSReplicaManager manager("rls://rls.nordugrid.org");
	list<string> coll;

	try {
		coll = manager.ListCollections();
	} catch(RLSReplicaManagerError e) {
		cout << e.what() << endl;
		return 0;
	}

	cout << "Collections:" << endl;
	list<string>::iterator it;
	for (it = coll.begin(); it != coll.end(); it++) {
		cout << "  < " << (*it) << " > " << endl;
		cout << endl;
	
		list<string> locs;
		try {
			locs = manager.ListLocations(*it);
		} catch(RLSReplicaManagerError e) {
			cout << e.what() << endl;
			return 0;
		}

		cout << "Locations for < " << *it << " > :" << endl;

		list<string>::iterator it2;
   		for (it2 = locs.begin(); it2 != locs.end(); it2++) {
			cout << "  < " << (*it2) << " > " << endl;
		}
	}

	return 0;
}
