#include <iostream>
#include <list>

#include <arc/runtimeenvironment.h>

int main() {

	RuntimeEnvironment RE0("ATLAS-9.0.3");
	std::cout << "RE0: " << RE0.str() << std::endl;
	std::cout << "Name: " << RE0.Name() << "  Version: " << RE0.Version() << std::endl << std::endl;

	RuntimeEnvironment RE1("APPS/HEP/ATLAS-9.0.3");
	std::cout << "RE1: " << RE1.str() << std::endl;
	std::cout << "Name: " << RE1.Name() << "  Version: " << RE1.Version() << std::endl << std::endl;

	RuntimeEnvironment RE2("BIO-GEIJER-0.0.2");
	std::cout << "RE2: " << RE2.str() << std::endl;
	std::cout << "Name: " << RE2.Name() << "  Version: " << RE2.Version() << std::endl << std::endl;

	RuntimeEnvironment RE3("P1SITE");
	std::cout << "RE3: " << RE3.str() << std::endl;
	std::cout << "Name: " << RE3.Name() << "  Version: " << RE3.Version() << std::endl << std::endl;

	RuntimeEnvironment RE4("MPICH/1.2.6/GCC4");
	std::cout << "RE4: " << RE4.str() << std::endl;
	std::cout << "Name: " << RE4.Name() << "  Version: " << RE4.Version() << std::endl << std::endl;

	RuntimeEnvironment RE5("APPL/CHEM/GAMESS-20041122");
	std::cout << "RE5: " << RE5.str() << std::endl;
	std::cout << "Name: " << RE5.Name() << "  Version: " << RE5.Version() << std::endl << std::endl;

	RuntimeEnvironment RE6("GAUSSIAN-03.B05");
	std::cout << "RE6: " << RE6.str() << std::endl;
	std::cout << "Name: " << RE6.Name() << "  Version: " << RE6.Version() << std::endl << std::endl;

	RuntimeEnvironment RE7("BIO-GEIJER");
	std::cout << "RE7: " << RE7.str() << std::endl;
	std::cout << "Name: " << RE7.Name() << "  Version: " << RE7.Version() << std::endl << std::endl;

	RuntimeEnvironment RE8("ENV/LOCALDISK");
	std::cout << "RE8: " << RE8.str() << std::endl;
	std::cout << "Name: " << RE8.Name() << "  Version: " << RE8.Version() << std::endl << std::endl;

	RuntimeEnvironment RE9("APPS/PHYSICS/HEP/ROOT-3.10.02");
	std::cout << "RE9: " << RE9.str() << std::endl;
	std::cout << "Name: " << RE9.Name() << "  Version: " << RE9.Version() << std::endl << std::endl;

	RuntimeEnvironment RE10("nordugrid-unknown");
	std::cout << "RE10: " << RE10.str() << std::endl;
	std::cout << "Name: " << RE10.Name() << "  Version: " << RE10.Version() << std::endl << std::endl;

	RuntimeEnvironment RE11("nordugrid-20051025cvs");
	std::cout << "RE11: " << RE11.str() << std::endl;
	std::cout << "Name: " << RE11.Name() << "  Version: " << RE11.Version() << std::endl << std::endl;

	RuntimeEnvironment RE12("nordugrid-0.5.26");
	std::cout << "RE12: " << RE12.str() << std::endl;
	std::cout << "Name: " << RE12.Name() << "  Version: " << RE12.Version() << std::endl << std::endl;

	RuntimeEnvironment RE13("nordugrid-0.4.3");
	std::cout << "RE13: " << RE13.str() << std::endl;
	std::cout << "Name: " << RE13.Name() << "  Version: " << RE13.Version() << std::endl << std::endl;

	std::list<RuntimeEnvironment> alist;
	alist.push_back(RE0);
	alist.push_back(RE1);
	alist.push_back(RE2);
	alist.push_back(RE3);
	alist.push_back(RE4);
	alist.push_back(RE5);
	alist.push_back(RE6);
	alist.push_back(RE7);
	alist.push_back(RE8);
	alist.push_back(RE9);
	alist.push_back(RE10);
	alist.push_back(RE11);
	alist.push_back(RE12);
	alist.push_back(RE13);

	alist.sort();

	std::cout << "Sorted list:" << std::endl;
	std::list<RuntimeEnvironment>::iterator it;
	for (it = alist.begin(); it != alist.end(); it++)
		std::cout << it->str() << std::endl;
}
