#include "xmlwrap.h"

#include "message.h"

FlOMessage::FlOMessage(const FlOObject& o,FlOObject::action_t t):object_(o),type_(t) { };

FlOMessage::FlOMessage(FlOObject::action_t t):object_(NULL),type_(t) { };

void FlOMessage::serialize(std::string& msg) {
  odlog(3)<<"FlOMessage: serialize: type: "<<type_<<endl;
  odlog(3)<<"FlOMessage: serialize: object: type: "<<object_->type()<<endl;
  odlog(3)<<"FlOMessage: serialize: object: id: "<<object_->id()<<endl;
  XMLNode x("message");
  XMLNode x_type(x,"type");
  XMLNode x_obj(x,"object");
  switch(type_) {
    case FlOObject::created: x_type.content("created"); break;
    case FlOObject::updated: x_type.content("updated"); break;
    case FlOObject::deleted: x_type.content("deleted"); break;
  };
  object_->serialize(x_obj,*this);
  msg=x.get();
}

FlOMessage* FlOMessage::deserialize(const std::string& msg) {
  odlog(3)<<"FlOMessage: deserialize: message: "<<msg<<endl;
  XMLNode x;
  x.set(msg);
  if(!x) return NULL;
  odlog(3)<<"FlOMessage: deserialize: name: "<<x.name()<<endl;
  if(x.name() != "message") { *((char*)NULL) = 55; return NULL; };
  odlog(3)<<"FlOMessage: deserialize: is message"<<endl;
  FlOMessage* m = NULL;
  XMLNode* x_type = x.getNode("type");
  XMLNode* x_obj = x.getNode("object");
  if(x_type) odlog(3)<<"FlOMessage: deserialize: has type"<<endl;
  if(x_obj) odlog(3)<<"FlOMessage: deserialize: has object"<<endl;
  if((x_type != NULL) && (x_obj != NULL)) {
    FlOObject::action_t m_type = FlOObject::unknown;
    std::string cnt;
    cnt=x_type->content();
    odlog(3)<<"FlOMessage: deserialize: type: "<<cnt<<endl;
    if(cnt == "created") { m_type=FlOObject::created; }
    else if(cnt == "updated") { m_type=FlOObject::updated; }
    else if(cnt == "deleted") { m_type=FlOObject::deleted; };
    FlOObject* o = FlOObject::deserialize(*x_obj);
    if(o) odlog(3)<<"FlOMessage: deserialize: object deserialized"<<endl;
    if(o) m=new FlOMessage(*o,m_type);
  };
  if(x_type != NULL) delete x_type;
  if(x_obj != NULL) delete x_obj;
  return m;
}

