#include "std.h"
#include "datamove/datapoint.h"
#include "datamove/datahandle.h"
#include "misc/log_time.h"

#ifdef NG_WRAPPER
extern "C" {
#endif
int ngregister(int argc,char** argv) {
  LogTime::active=false;
  bool verbose = false;
  for(;;) {
    opterr=0;
    int optc=getopt(argc,argv,"+hvd:c");
    if(optc == -1) break;
    switch(optc) {
      case 'h': {
        olog<<"ngregister [-h] [-v] [-d level] [-c] url"<<endl;
        olog<<" -h - print help"<<endl;
        olog<<" -v - print version"<<endl;
        olog<<" -d - set debug level"<<endl;
        olog<<" -c - continue removing meta information even if failed to delete physical file instance"<<endl;
        exit(1);
      }; break;
      case 'v': {
        olog<<"ngregister: version "<<VERSION<<endl;
        exit(0);
      };
      case 'd': {
        char* p;
        int i = strtol(optarg,&p,10);
        if(((*p) != 0) || (i<0)) {
          olog<<"Improper debug level '"<<optarg<<"'"<<endl;
          exit(1);
        };
        verbose=true;
        LogTime::level=i;
      }; break;
      case 'c': {
        errcont=true;
      }; break;
      case '?': {
        olog<<"Unsupported option '"<<(char)optopt<<"'"<<endl;
        exit(1);
      }; break;
      case ':': {
        olog<<"Missing parameter for option '"<<(char)optopt<<"'"<<endl;
        exit(1);
      }; break;
      default: {
        olog<<"Undefined processing error"<<endl;
        exit(1);
      };
    };
  };
  if(verbose) { cout<<"Registration succeeded"<<endl; };
  return 0;
}
#ifdef NG_WRAPPER
};
#endif

