/*
 * Created on Apr 10, 2006
 * 
 * Simplifies handling of JSDL documents. 
 *
 */
package se.umu.jobsubmission.util;

import org.ggf.schemas.jsdl._2005._11.jsdl.JobDefinition_Type;

import se.umu.jobsubmission.JobPreferencesType;
import se.umu.jobsubmission.impl.dispatcher.Dispatcher;

/**
 * @author tordsson
 *
 * TODO Add a proper description of this class. 
 */
public class JSDLUtils {

	
	public static int getDuration(JobDefinition_Type jobDesc) {
		try { 
			return (int) jobDesc.getJobDescription().getResources().
						getIndividualCPUTime().getExact(0).get_value(); 
		} catch (Exception e) { 
			return Dispatcher.DEFAULT_CPU_TIME * 60; // In seconds. 
		}
	}
	
	public static boolean getFlexible(JobPreferencesType jobPreferences) { 
    	try {
    		 return jobPreferences.getJobRequirement().
					getFlexible().booleanValue(); 
    	} catch (Exception e) {
    		return false; 
    	}
	}
	
	public static int getNumberOfCPUs(JobDefinition_Type jobDesc) { 
		try {
    		return (int) jobDesc.getJobDescription(). 
					getResources().getTotalCPUCount().getExact()[0].get_value();
    	}	
    	catch (Exception e) {
    		return 1;    		
    	}   
	}
	
	// Let the default value be 0 as this makes sense for 
	// comparing two jobs where one have not specified 
	public static int getMemory(JobDefinition_Type jobDesc) {
		try {
			return (int) jobDesc.getJobDescription().
				getResources().getIndividualPhysicalMemory().getExact()[0].get_value(); 			
		}
		catch (Exception e) {
			return 0; 			
		}
	}
	
}
