/*
 * Created on Apr 19, 2005
 */
package se.umu.wsag.impl;

import org.ggf.ws_agreement.AgreementType;
import org.ggf.ws_agreement.ServiceDescriptionTermType;

import se.umu.reservation.DecisionMakerConfig;

/**
 * @author tordsson
 *
 * This class interfaces the local "Agreement Management System", 
 * and has two methodes. The create method performs admission control 
 * and is called by the AgreementFactoryService before an AgreementResource
 * is created. The remove method is called by the AgreementResource upon 
 * termination of the resource. 
 */
public interface AgreementDecisionMaker {

	// Could pass a DecisionMakerConfig to init instead of an object...
	public void init(Object context) throws Exception; 
	public DecisionMakerConfig getConfig(); 
	public AgreementDecision create(AgreementType offer);
	public void cancel(ServiceDescriptionTermType terms); 
	public int getInitialAgreementLifeTime(); 

}
